'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
function applyUpdate(updates) {
    return function (entity) {
        if (!entity)
            return;
        var updated = entity.merge(updates);
        return updated.save()
            .then(function (result) {
            return result;
        });
    };
}
exports.applyUpdate = applyUpdate;
function removeEntity() {
    return function (entity) {
        if (!entity)
            return;
        return entity.remove()
            .then(function (removed) {
            return removed;
        });
    };
}
exports.removeEntity = removeEntity;
function createEntity(model) {
    return function (entity) {
        return model.create(entity);
    };
}
exports.createEntity = createEntity;
function findEntityById(model, id) {
    return model.findById(id)
        .exec();
}
exports.findEntityById = findEntityById;
