"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var controller_utils_1 = require("../utils/controller.utils");
var ControllerUtils = (function () {
    function ControllerUtils(service) {
        this.service = service;
    }
    ControllerUtils.prototype.find = function (req, res, queryExecutor) {
        var sortBy = req.query.sort;
        var currentPage = req.query.page || 1;
        var perPage = req.query.per_page || 200;
        queryExecutor
            .execCount()
            .then(function (totalCount) {
            res.set('X-Total-Count', String(totalCount));
            return queryExecutor.execFind(sortBy, currentPage, perPage);
        })
            .then(controller_utils_1.respondWithResult(res))
            .catch(controller_utils_1.handleError(res));
    };
    return ControllerUtils;
}());
exports.ControllerUtils = ControllerUtils;
