"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var logger_1 = require("../logger");
function createQueryExecutor(model, queryBuilder) {
    var self = this;
    var executor = {};
    executor.execCount = function () {
        return self.execCount(model, queryBuilder);
    };
    executor.execFind = function (sortBy, currentPage, perPage) {
        return self.execFind(model, queryBuilder, sortBy, currentPage, perPage);
    };
    return executor;
}
exports.createQueryExecutor = createQueryExecutor;
//Query utils
function execFind(model, queryBuilder, sortBy, currentPage, perPage) {
    logger_1.default.info(queryBuilder, model.collection.collectionName + ".execFind()");
    var query = queryBuilder(model.find());
    if (sortBy)
        query.sort(sortBy);
    if (currentPage > 0 && perPage > 0)
        query
            .skip((currentPage - 1) * perPage)
            .limit(perPage);
    return query.exec();
}
exports.execFind = execFind;
function execCount(model, queryBuilder) {
    logger_1.default.info(queryBuilder, model.collection.collectionName + ".execCount()");
    return queryBuilder(model.count(null)).exec();
}
exports.execCount = execCount;
